/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _DATAITEMQUANTIFIEDEXPR_HPP
#define _DATAITEMQUANTIFIEDEXPR_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemFor.hpp>

/** Some/Every function. */
class PATHAN_EXPORT DataItemQuantifiedExpr : public DataItemFor
{
public:
  typedef enum {some, every} QuantifierType;

  DataItemQuantifiedExpr(QuantifierType qType, VectorOfBindings* bindings, DataItem* returnExpr, XPath2MemoryManager* memMgr);
  
  virtual DataItem* staticResolution(StaticContext *context, StaticResolutionContext *src);

  QuantifierType getQuantifierType() const;

protected:
  virtual Sequence collapseTreeInternal(Bindings::const_iterator it, Bindings::const_iterator end, DynamicContext* context, int flags = 0) const;

  QuantifierType _qType;
};

#endif // _DATAITEMQUANTIFIEDEXPR_HPP

