/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  NavigationDSLException - exception class for navigation

*/

#ifndef _NAVIGATIONEXCEPTION_HPP
#define _NAVIGATIONEXCEPTION_HPP

#include <pathan/Pathan.hpp>

#include <pathan/exceptions/DSLException.hpp>
#include <pathan/internal/DOMutils/XStr.hpp>

/** exception class for tests. Inherit from this if you need to throw an exception
    in the test suite.*/
class PATHAN_EXPORT NavigationException : public DSLException
{
public:
  
  NavigationException(const XMLCh *functionName, const XMLCh *reason, const char *file, int line)
    : DSLException(X("NavigationException"), functionName, reason, file, line) {};
};

#endif // _NAVIGATIONEXCEPTION_HPP
