/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _PRECEDINGAXIS_HPP
#define _PRECEDINGAXIS_HPP

#include <pathan/Pathan.hpp>

#include <pathan/internal/navigation/ReverseAxis.hpp>

/**
This class implements the PrecedingAxis axis as defined by the XPath spec
*/
class PATHAN_EXPORT PrecedingAxis : public ReverseAxis
{
public:
  virtual Axis getAxis() const;
protected:
  virtual Sequence makeList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XMLCh* const uri, DynamicContext* context) const;
  Sequence buildAncestorList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, XPath2MemoryManager* memMgr) const;
  void addChildrenUntilNode(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *stopNode, Sequence *retList, const XMLCh* const uri, DynamicContext* context) const;
  void addTree(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, Sequence *retList, const XMLCh* const uri, DynamicContext* context) const;
};


#endif

