/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   NotEquals operator function
*/

#ifndef _NOTEQUALS_HPP
#define _NOTEQUALS_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** OpNotEquals operator function*/
class PATHAN_EXPORT NotEquals : public DataItemOperator
{
public:
  static const XMLCh name[];

  NotEquals(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  static bool not_equals(const Item* arg1, const Item* arg2, DynamicContext* context);

  /** Takes two DataItems and returns true if they are not equal*/
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;
};

#endif // _NOTEQUALS_HPP
